<?php

$url = "";
$file = "";
if(isset($argv[1])) {
	$url = $argv[1];
}

if(isset($argv[2])) {
	$file = $argv[2];
}

if($url == "" || $file == "") {
	echo "need a url and file\n";
	exit(0);
}

// first check any directories in $file are in existence
$splfile = explode("/", $file);
if(count($splfile) > 1) {
	$tomake = "";
	for($i = 0; $i < count($splfile)-1; $i++) {
		$tomake .= "/".$splfile[$i];
		echo("making directory $tomake");
		if(!is_dir($tomake)) mkdir($tomake);
	}
}


// ok, we kick off a download
if(file_exists("$file")) {
	// a download exists, does it still work
	error_log("DOWNLOADER: file exists for current download, hope it works, attempting lock");
	$localtmpfh = fopen("$file", "r");
	$lockres = flock($localtmpfh, LOCK_EX|LOCK_NB);
	if(!$lockres) {
		error_log("flock did fail, all is right with the world a download is in progress");
		exit(0);
	} else {
		error_log("lock succeeded, dieing in the arse");
		unlink("$file");
		if(file_exists("$file.size")) unlink("$file.size");
	}
}

$remotefile = fopen($url, "r");

// check if ther mote file started
if(!$remotefile) {
	foreach($http_response_header as $key => $val) {
		if(preg_match("/HTTP.*404.*/", $val)) {
			echo "got a 404 touching 404 file\n";
			touch("$file.404");
			exit(0);
		}
	}
} else {
	if(file_exists("$file.404")) {
		unlink("$file.404");
	}
}

$localfile = fopen($file, "w");
$lockres = flock($localfile, LOCK_EX);
if(!$localfile) {
	echo "something went plop\n";
	return;
}


// get the headers from the remote request and use them to hurt people
$contentlen = 0;
$contenttype = "";

// detecting a remote directory on a web session is near impossible, this is the best i can come up with
// - check for a redirection header, then look for a trailing / on the url... best of luck to me
foreach($http_response_header as $key => $val) {
	if(preg_match("/.*Location:.*/", $val)) {
		echo "got location as $val\n";
		$realloc = preg_replace("/.*[: ]/", "", $val);
		if(preg_match("/.*\/$/", $realloc)) {
			echo "matched\n";
			fclose($localfile);
			unlink($file);
			mkdir($file);
			exit(0);
		}
	}
	// get content length form upstream and print
	if(preg_match("/^Content-Length:.*/", $val)) {
		$clentemp = preg_split("/[: ]+/", $val);
		$contentlen = $clentemp[1];
		//header($val);
	}
	// get content type from upstream and print
	if(preg_match("/^Content-Type:.*/", $val)) {
		$contenttype = $val;	
	}
	if(!$remotefile) {
		return;
	}
	 
}

file_put_contents("$file.size", $contentlen);

while(!feof($remotefile)) {
	$data = fread($remotefile, 2048);
	fwrite($localfile, $data);
}

//rename("$file.tmp.data.deleteme", $file);
unlink("$file.size");

?>